package ru.team418.rlt.telegram.services;

import org.springframework.stereotype.Service;
import ru.team418.rlt.telegram.enteties.Article;
import ru.team418.rlt.telegram.repositories.ArticleRepository;
import ru.team418.rlt.telegram.views.ArticleView;
import ru.team418.rlt.telegram.views.LinkButtonView;
import ru.team418.rlt.telegram.views.PhotoView;

import javax.annotation.PostConstruct;
import javax.persistence.EntityNotFoundException;
import javax.transaction.Transactional;
import java.util.Collection;
import java.util.List;
import java.util.Set;

@Service
@Transactional
public class ArticleService {

    private final ArticleRepository repository;

    public ArticleService(ArticleRepository repository) {
        this.repository = repository;
    }

    public Article getByCommand(String command) {
        return repository.findByCommand(command)
                .orElseThrow(EntityNotFoundException::new);
    }

    public void save(ArticleView articleView) {
        repository.save(new Article(articleView));
    }

    public void saveAll(Collection<ArticleView> articleViews) {
        repository.saveAll(articleViews.stream().map(Article::new).toList());
    }

    @PostConstruct
    public void seed/*и нэнси*/() {
        repository.deleteAll();
        if (repository.findByCommand("/article_1").isEmpty())
            this.saveAll(Set.of(
                    new ArticleView(null, "/article_1", SeedArticlesText.ARTICLE_1_TEXT,
                            List.of(new PhotoView(null, "https://plus.unsplash.com/premium_photo-1677340725081-e81626d96e29?ixlib=rb-4.0.3&ixid=MnwxMjA3fDB8MHxzZWFyY2h8MXx8ZG9jdW1lbnRzfGVufDB8fDB8fA%3D%3D&auto=format&fit=crop&w=500&q=60")),
                            List.of(new LinkButtonView(null, "/article_2", "Про пользу для экологии."))
                    ),
                    new ArticleView(null, "/article_2", SeedArticlesText.ARTICLE_2_TEXT,
                            List.of(new PhotoView(null, "https://images.unsplash.com/photo-1583521214690-73421a1829a9?ixlib=rb-4.0.3&ixid=MnwxMjA3fDB8MHxzZWFyY2h8Nnx8ZG9jdW1lbnRzfGVufDB8fDB8fA%3D%3D&auto=format&fit=crop&w=500&q=60")),
                            List.of(
                                    new LinkButtonView(null, "/article_4", "ЭОД - это удобно"),
                                    new LinkButtonView(null, "/article_5", "ЭОД - это быстро"),
                                    new LinkButtonView(null, "/article_6", "ЭОД - это безопасно")
                            )
                    ),
                    new ArticleView(null, "/article_4", SeedArticlesText.ARTICLE_4_TEXT,
                            List.of(new PhotoView(null, "https://images.unsplash.com/photo-1628348068343-c6a848d2b6dd?ixlib=rb-4.0.3&ixid=MnwxMjA3fDB8MHxzZWFyY2h8MjZ8fGRvY3VtZW50c3xlbnwwfHwwfHw%3D&auto=format&fit=crop&w=500&q=60")),
                            List.of(
                                    new LinkButtonView(null, "/article_5", "ЭОД - это быстро"),
                                    new LinkButtonView(null, "/article_6", "ЭОД - это безопасно")
                            )
                    ),
                    new ArticleView(null, "/article_5", SeedArticlesText.ARTICLE_5_TEXT,
                            List.of(new PhotoView(null, "https://images.unsplash.com/photo-1568844590215-b7d899a731b4?ixlib=rb-4.0.3&ixid=MnwxMjA3fDB8MHxzZWFyY2h8MzZ8fGRvY3VtZW50c3xlbnwwfHwwfHw%3D&auto=format&fit=crop&w=500&q=60")),
                            List.of(
                                    new LinkButtonView(null, "/article_4", "ЭОД - это удобно"),
                                    new LinkButtonView(null, "/article_6", "ЭОД - это безопасно")
                            )
                    ),
                    new ArticleView(null, "/article_6", SeedArticlesText.ARTICLE_6_TEXT,
                            List.of(new PhotoView(null, "https://images.unsplash.com/photo-1548092372-0d1bd40894a3?ixlib=rb-4.0.3&ixid=MnwxMjA3fDB8MHxzZWFyY2h8M3x8c2VjdXJpdHl8ZW58MHx8MHx8&auto=format&fit=crop&w=500&q=60")),
                            List.of(
                                    new LinkButtonView(null, "/article_4", "ЭОД - это удобно"),
                                    new LinkButtonView(null, "/article_5", "ЭОД - это быстро")
                            )
                    )
            ));
    }

    private static class SeedArticlesText {

        public static final String ARTICLE_1_TEXT = "Документооборот – это система электронного обмена документами между компаниями, организациями и государственными учреждениями. Он позволяет упростить работу с бумажными документами, сократить время на их обработку и минимизировать риски ошибок.\n" +
                "\n" +
                "Первая и основная польза документооборота – это экономия времени и ресурсов. Все документы хранятся в электронном виде и могут быть отправлены и получены в любой момент времени, в любой точке мира. К примеру, если вам нужно получить подпись руководителя на важном документе, вы можете сразу же отправить ему его электронную копию, вместо того чтобы выписывать ее, затем отправлять по почте или курьером.\n" +
                "\n" +
                "Второй преимуществом – это повышение контроля за бизнес-процессами. В электронном документообороте все этапы обработки документов легко контролируются и могут быть отслежены. Это позволяет быстро выявлять ошибки и устранять их на ранней стадии.\n" +
                "\n" +
                "Третий плюс – это повышение квалификации сотрудников. Во время работы с электронными документами, сотрудники учатся работать со специальными программами и применять в работе новые технологии. Это значительно повышает их квалификацию и увеличивает эффективность работы.\n" +
                "\n" +
                "Наконец, последней и не менее важной пользой документооборота является уменьшение рисков потери документов и взлома системы хранения данных. Электронные документы хранятся в безопасных хранилищах, к которым имеют доступ только уполномоченные лица.\n" +
                "\n" +
                "Таким образом, документооборот имеет множество преимуществ для предприятий, компаний и государственных учреждений. Он позволяет экономить время и ресурсы, повышать контроль над бизнес-процессами и квалификацию сотрудников, а также минимизировать риски потери документов и взлома системы хранения данных.";

        public static final String ARTICLE_2_TEXT = "Электронный документооборот – спасение для деревьев\n" +
                "\n" +
                "В настоящее время, когда наблюдается настоящий экономический рост в нескольких отраслях деятельности включая бизнес, внедрение электронного документооборота становится все более распространенным. Экономия на бумаге, времени и деньгах в сочетании с экологической выгодой делают эту технологию популярной. Современные компании и предприятия осознают приоритетность принципов устойчивого развития и экологически ответственного поведения. Одним из способов достижения этой цели является рациональное использование природных ресурсов, в том числе – лесных.\n" +
                "\n" +
                "Вместо целых рядов файлов, документов и бумажной корреспонденции, используемых в работе бизнеса, электронный документооборот значительно экономит ресурсы и, результатом этого, является сбережение целых деревьев. В большинстве организаций, бумажные документы и дневники по-прежнему являются распространенным способом работы, но с развитием технологий это устаревает и вредно для окружающей среды.\n" +
                "\n" +
                "Бумага – это один из наиболее разрушительных материалов, которые мы используем. На производство 1 тонны бумаги нужно 24 дерева, 7000 галлонов воды и около 450 киловатт-часов электрической энергии. Ресурсы, используемые для производства бумаги, также включают в себя различные химические вещества, отходы и загрязнения окружающей среды, которые оказывают негативное влияние на экологическую ситуацию.\n" +
                "\n" +
                "К счастью, электронный документооборот предлагает практичное и удобное решение для этой проблемы. Он предоставляет возможность выращивать и сохранять целые леса путем применения электронных документов и электронной корреспонденции. Существует возможность хранения огромного количества информации в электронном виде, сокращение времени и затрат, связанных с бумажными документами, а также большое количество других преимуществ.\n" +
                "\n" +
                "Кроме того, электронный документооборот дает возможность избежать большого количества ошибок, связанных с ручным вводом данных, и ускорить перенос информации. Он также дает возможность сохранять информацию с высоким уровнем безопасности, а всю информацию можно резервировать и защитить с помощью специального программного обеспечения.\n" +
                "\n" +
                "В целом, введение электронного документооборота в бизнес-процессы помагает не только сэкономить время и деньги, но и предоставляет возможность сократить экологические затраты, в том числе – сохранение целых лесов и огромных количеств ресурсов.\n" +
                "\n" +
                "Таким образом, когда мы все более ориентируемся на серьезные ограничения ресурсов и стараемся внедрять практические подходы к устойчивому развитию, электронный документооборот дает возможность сохранять леса и сохранять окружающую среду, при этом повышая эффективность работы и качество оказываемых услуг.";

        public static final String ARTICLE_4_TEXT = "Электронный документооборот дает возможность избежать большого количества ошибок, связанных с ручным вводом данных, и ускорить перенос информации. Он также дает возможность сохранять информацию с высоким уровнем безопасности, а всю информацию можно резервировать и защитить с помощью специального программного обеспечения.\n" +
                "\n" +
                "В целом, введение электронного документооборота в бизнес-процессы помагает не только сэкономить время и деньги, но и предоставляет возможность сократить экологические затраты, в том числе – сохранение целых лесов и огромных количеств ресурсов.\n" +
                "\n" +
                "Таким образом, когда мы все более ориентируемся на серьезные ограничения ресурсов и стараемся внедрять практические подходы к устойчивому развитию, электронный документооборот дает возможность сохранять леса и сохранять окружающую среду, при этом повышая эффективность работы и качество оказываемых услуг.";

        public static final String ARTICLE_5_TEXT = "В настоящее время электронный документооборот стал неотъемлемой частью бизнес-процессов в компаниях различных отраслей. Это связано с тем, что электронный документооборот позволяет значительно ускорить обмен документами, сократить временные затраты на их обработку, минимизировать количество ошибок, повысить эффективность бизнес-процессов и сократить расходы на бумажные носители и услуги курьерских служб.\n" +
                "\n" +
                "В отличие от бумажного документооборота, который подразумевает физическое перемещение документов, электронный документооборот предоставляет возможность передавать и обрабатывать документы в электронном виде. Это позволяет избежать недостатков бумажного документооборота, таких как задержки в доставке документов, потери документов, ошибки при их обработке и т.д.";

        public static final String ARTICLE_6_TEXT = "Многие люди, однако, все еще не уверены в безопасности использования электронных документов. Возможность хакерских атак, киберпреступлений и взломов серверов вызывает у них опасения по поводу сохранности информации в электронном виде.\n" +
                "\n" +
                "Однако, следует отметить, что электронный документооборот является довольно безопасным способом передачи и хранения информации. Во-первых, у электронных документов есть высокий уровень защиты. Это достигается за счет использования различных шифровальных алгоритмов и протоколов безопасности, а также за счет соблюдения определенных стандартов и требований по безопасности информации.\n" +
                "\n" +
                "Во-вторых, при работе с электронными документами существует возможность контроля доступа к информации. Это означает, что только те сотрудники, которым предоставлено специальное разрешение, могут получить доступ к определенной информации, что повышает ее безопасность.\n" +
                "\n" +
                "В-третьих, электронный документооборот предполагает возможность создания резервных копий данных. Это означает, что в случае непредвиденных обстоятельств (например, вирусной атаки или отказа жесткого диска) информацию можно восстановить из сохраненной копии.\n" +
                "\n" +
                "В-четвертых, электронные документы могут быть защищены паролем и иметь возможность шифрования, что позволяет улучшить уровень безопасности хранения и передачи данных.\n" +
                "\n" +
                "Таким образом, можно сделать вывод, что электронный документооборот – это безопасный и удобный способ работы, позволяющий существенно снизить временные и финансовые затраты на обработку и хранение документов, а также улучшить уровень безопасности информации. Учитывая все вышеперечисленное, можно с уверенностью сказать, что использование электронных документов является безопасным и эффективным способом работы.";

    }


}

